'use strict';

exports.__esModule = true;
exports.assign = assign;

var _promisifiedFunctions = require('../../utils/promisified-functions');

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};

let cached = null;
function queryOSForCredential(cmd) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const credential = yield (0, _promisifiedFunctions.exec)(cmd);
            return credential.replace(/\s/g, '');
        } catch (err) {
            return '';
        }
    });
}
function assign(credentials) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!cached) {
            cached = {
                domain: yield queryOSForCredential('echo %userdomain%'),
                workstation: yield queryOSForCredential('hostname')
            };
        }
        credentials.domain = credentials.domain || cached.domain;
        credentials.workstation = credentials.workstation || cached.workstation;
    });
}